#!/usr/bin/python3

import sys
import os
import xml.etree.ElementTree as ET
import argparse

numtrue = 0

def gml_to_xml(gmlfilename):
    os.system('./gml-to-xml.sh ' + gmlfilename)

def process_node(node):
    global numtrue
    tv = node.find('tv').text
    if tv == 'true':
        numtrue += 1
        asgn = node.find('tp').find('assignment')
        # print(asgn)
        var = asgn.find('var').text
        filename = 'assignment-' + var + '-' + str(numtrue) + '.red'
        # print(filename)
        f = open(filename, 'w')
        f.write('ratpoly_' + var + ' := simp xread t$\n')
        f.write(asgn.find('poly').text + '$\n')
        f.write('lb_' + var + ' := simp xread t$\n')
        f.write(asgn.find('lb').text + '$\n')
        f.write('rb_' + var + ' := simp xread t$\n')
        f.write(asgn.find('rb').text + '$\n')
        f.write('end;\n')
        f.close()

if __name__ == '__main__':
    p = argparse.ArgumentParser(description = 'Generate .red files from a gml CAD tree.')
    p.add_argument('input', help = 'the input gml file', metavar = 'GMLFILE')
    args = p.parse_args()

    gmlfilename = args.input
    gml_to_xml(gmlfilename)
    xmlfilename = gmlfilename.replace('.gml', '.xml')
    redbasename = xmlfilename.replace('.xml', '')

    root = ET.parse(xmlfilename).getroot()
    # nodes = root.find('nodes')

    for node in root:
        process_node(node)
        # print(node)
